From bb1d2ef042b52015832d4612ec2a29d49e683f3d Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Mar 30 2016 14:57:42 +0000
Subject: [PATCH 366/1001] Merge branch 'feature/cache-invalidator-enhancements' into develop


---

diff --git a/fedmsg.d/logging.py b/fedmsg.d/logging.py
index c31901c..3502cd9 100644
--- a/fedmsg.d/logging.py
+++ b/fedmsg.d/logging.py
@@ -19,22 +19,27 @@ config = dict(
                 "stream": "ext://sys.stdout",
             },
         ),
-        loggers=dict(
-            fedmsg={
+        loggers={
+            "fedmsg": {
                 "level": "INFO",
                 "propagate": False,
                 "handlers": ["console"],
             },
-            moksha={
+            "moksha": {
                 "level": "INFO",
                 "propagate": False,
                 "handlers": ["console"],
             },
-            hubs={
+            "hubs": {
                 "level": "DEBUG",
                 "propagate": False,
                 "handlers": ["console"],
             },
-        ),
+            "fmn.rules": {
+                "level": "ERROR",
+                "propagate": False,
+                "handlers": ["console"],
+            }
+        },
     ),
 )
diff --git a/fedmsg.d/testconfig.py b/fedmsg.d/testconfig.py
index ec13c43..e85072e 100644
--- a/fedmsg.d/testconfig.py
+++ b/fedmsg.d/testconfig.py
@@ -25,6 +25,15 @@ config = {
         },
     },
 
+    # Some configuration for the general hubs cache.
+    "fedora-hubs.cache": {
+        "backend": "dogpile.cache.dbm",
+        "expiration_time": -1,  # Expire every 1 second, for development
+        "arguments": {
+            "filename": "/var/tmp/fedora-hubs-cache.db",
+        },
+    },
+
     # Run datanommer locally, just for development.
     'datanommer.enabled': True,
     'datanommer.sqlalchemy.url': 'postgres://postgres:laksjdf@127.0.0.1/datanommer',
diff --git a/hubs/consumer.py b/hubs/consumer.py
index bd7345e..c6e0d7b 100755
--- a/hubs/consumer.py
+++ b/hubs/consumer.py
@@ -4,11 +4,15 @@ import collections
 import threading
 import time
 
+import munch
+
 import datanommer.models
 import fedmsg.consumers
 import fedmsg.meta
 
+import hubs.app
 import hubs.models
+import hubs.widgets
 
 from hubs.widgets.base import invalidate_cache
 
@@ -16,6 +20,20 @@ import logging
 log = logging.getLogger("hubs")
 
 
+def j(widget):
+    """ Shorthand to reduce a sqlalchemy widget to a munch for processing. """
+    return munch.Munch(dict(
+        idx=widget.idx,
+        hub_id=widget.hub_id,
+        hub=munch.Munch(dict(
+            name=widget.hub.name,
+        )),
+        plugin=widget.plugin,
+        config=widget.config,
+        # TODO -- add other things here as we need it
+    ))
+
+
 class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
     topic = '*'
     config_key = 'hubs.consumer.enabled'
@@ -50,29 +68,37 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
         self.checks_by_topic = collections.defaultdict(list)
         self.checks_by_category = collections.defaultdict(list)
         self.checks_by_username = collections.defaultdict(list)
+        self.ubiquitous_checks = list()
 
         widgets = session.query(hubs.models.Widget).all()
         log.info("Building lookup from  %i total widgets" % len(widgets))
         for widget in widgets:
-            check = widget.module.should_invalidate
+            module = hubs.widgets.registry[widget.plugin]
+            check = module.should_invalidate
 
             if not hasattr(check, 'hints'):
-                raise AttributeError("%r must declare hints" % widget.module)
+                raise AttributeError("%r must declare hints" % module)
+
+            item = (check, j(widget),)
 
             for topic in check.hints['topics']:
-                self.checks_by_topic[topic].append((check, widget,))
+                self.checks_by_topic[topic].append(item)
 
             for category in check.hints['categories']:
-                self.checks_by_category[category].append((check, widget,))
+                self.checks_by_category[category].append(item);
 
             usernames = check.hints['usernames_function'](widget)
             for username in usernames:
-                self.checks_by_username[username].append((check, widget,))
+                self.checks_by_username[username].append(item)
+
+            if check.hints['ubiquitous']:
+                self.ubiquitous_checks.append(item)
 
         log.info("Lookup sizes are:")
         log.info("- %i topics" % len(self.checks_by_topic))
         log.info("- %i categories" % len(self.checks_by_category))
         log.info("- %i usernames" % len(self.checks_by_username))
+        log.info("- %i ubiquitous" % len(self.ubiquitous_checks))
 
     @property
     def lookup_initialized(self):
@@ -81,15 +107,19 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
     def consume(self, raw_msg):
         session = self.make_session()
         try:
-            self.work(session, raw_msg)
+            with hubs.app.app.app_context():  # so url_for works
+                self.work(session, raw_msg)
             session.commit()  # transaction is committed here
         except:
             session.rollback()  # rolls back the transaction
             raise
+        finally:
+            session.close()
 
     def work(self, session, raw_msg):
         topic, msg = raw_msg['topic'], raw_msg['body']
         category = topic.split('.')[3]
+        usernames = fedmsg.meta.msg2usernames(msg, **self.hub.config)
 
         for suffix in self.junk_suffixes:
             if topic.endswith(suffix):
@@ -111,9 +141,12 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
 
         # Start this by finding a subset of widget checks that might match this
         # message. Look them up based on the hints they declare.
-        checks = set(
-            self.checks_by_topic[topic] + self.checks_by_category[category]
-        )
+        checks = sum([
+            self.checks_by_topic[topic],
+            self.checks_by_category[category],
+            sum([self.checks_by_username[u] for u in usernames], []),
+            self.ubiquitous_checks,
+        ], [])
 
         statement = "Found %i checks to try for this message" % len(checks)
         if checks:
@@ -125,10 +158,13 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
         # see if any tell us that we should nuke various data caches.
         for check, widget in checks:
             if check(msg, session, widget):
+                # Get a real widget, because we update last_refreshed on it.
+                widget = hubs.models.Widget.by_idx(session, widget.idx)
                 log.info("! Invalidating cache for %r" % widget)
                 # Invalidate the cache...
                 invalidate_cache(widget, **widget.config)
                 # Rebuild it.
+                log.info("! Rebuilding cache for %r" % widget)
                 widget.module.data(session, widget, **widget.config)
                 # TODO -- fire off an EventSource notice that we updated stuff
 
diff --git a/hubs/default_config.py b/hubs/default_config.py
index a21f138..a452867 100755
--- a/hubs/default_config.py
+++ b/hubs/default_config.py
@@ -6,3 +6,5 @@ PROMOTED_GROUPS = [
 ]
 
 HUB_OF_THE_MONTH = 'commops'
+
+SERVER_NAME = '0.0.0.0:5000'
diff --git a/hubs/hinting.py b/hubs/hinting.py
index b04d688..14ed445 100755
--- a/hubs/hinting.py
+++ b/hubs/hinting.py
@@ -6,11 +6,12 @@ import logging
 log = logging.getLogger('hubs.hinting')
 
 
-def hint(topics=None, categories=None, usernames=None):
+def hint(topics=None, categories=None, usernames=None, ubiquitous=False):
     topics = topics or []
     categories = categories or []
     default_usernames = lambda x: []
     usernames = usernames or default_usernames
+    ubiquitous = ubiquitous
 
     @decorator.decorator
     def wrapper(fn, *args, **kwargs):
@@ -22,6 +23,7 @@ def hint(topics=None, categories=None, usernames=None):
             topics=topics,
             categories=categories,
             usernames_function=usernames,
+            ubiquitous=ubiquitous,
         )
         return wrapped
 
diff --git a/hubs/models.py b/hubs/models.py
index abd92f4..086e0b1 100755
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -298,6 +298,12 @@ class Widget(BASE):
     index = sa.Column(sa.Integer, nullable=False)
     left = sa.Column(sa.Boolean, nullable=False, default=False)
 
+    @classmethod
+    def by_idx(cls, session, idx):
+        return session.query(cls).filter_by(idx=idx).first()
+
+    get = by_idx
+
     @property
     def config(self):
         return json.loads(self._config)
@@ -321,6 +327,9 @@ class Widget(BASE):
             'config': self.config,
         }
 
+    def __repr__(self):
+        return "<Widget %s /%s/%i>" % (self.plugin, self.hub.name, self.idx)
+
     @property
     def module(self):
         return hubs.widgets.registry[self.plugin]
diff --git a/hubs/tests/test_widgets/__init__.py b/hubs/tests/test_widgets/__init__.py
index 8914ab6..1e917ed 100644
--- a/hubs/tests/test_widgets/__init__.py
+++ b/hubs/tests/test_widgets/__init__.py
@@ -58,8 +58,6 @@ class WidgetTest(unittest.TestCase):
                 hub.last_updated = datetime.utcnow() - timedelta(days=200)
 
             hubs.app.session.add(hub)
-            widget = hubs.models.Widget(plugin='cobwebs', index=10)
-            hub.widgets.append(widget)
             widget = hubs.models.Widget(plugin='meetings', index=11,
                                         _config=json.dumps({'calendar': team}))
             hub.widgets.append(widget)
diff --git a/hubs/tests/test_widgets/test_meetings.py b/hubs/tests/test_widgets/test_meetings.py
index 0274255..90656fd 100644
--- a/hubs/tests/test_widgets/test_meetings.py
+++ b/hubs/tests/test_widgets/test_meetings.py
@@ -12,6 +12,12 @@ class TestMeetings(hubs.tests.test_widgets.WidgetTest):
         response = self.app.get('/%s/%i/json/' % (team, widget.idx))
         assert response.status_code == 200, response.status_code
         data = json.loads(response.data)
-        meetings = data['data']['meetings']["%s meeting" % team]
-        assert len(meetings) == 15, len(meetings)
-        assert team in meetings[0]['meeting_name']
+        meeting = data['data']['meetings']["%s meeting" % team]
+        assert team in meeting['meeting_name']
+
+    def test_render_simple(self):
+        team = 'i18n'
+        widget = self.widget_instance(team, self.plugin)
+        response = self.app.get('/%s/%i/' % (team, widget.idx))
+        assert response.status_code == 200, response.status_code
+        assert 'The i18n meeting is in' in response.data, response.data
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index cc7007c..551876a 100755
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -8,7 +8,6 @@ from hubs.widgets import linechart
 from hubs.widgets import fedmsgstats
 from hubs.widgets import feed
 from hubs.widgets import subscriptions
-from hubs.widgets import cobwebs
 from hubs.widgets import meetings
 from hubs.widgets import pagure_pr
 from hubs.widgets import github_pr
@@ -32,7 +31,6 @@ registry = {
     'fedmsgstats': fedmsgstats,
     'feed': feed,
     'subscriptions': subscriptions,
-    'cobwebs': cobwebs,
     'meetings': meetings,
     'pagure_pr': pagure_pr,
     'github_pr': github_pr,
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index f1f84cb..dc7b229 100755
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -57,9 +57,9 @@ def AGPLv3(name):
 def smartcache(func):
     @wraps(func)
     def inner(session, widget, *args, **kwargs):
-        key = cache_key_generator(widget, args, kwargs)
+        key = cache_key_generator(widget, *args, **kwargs)
         creator = lambda: func(session, widget, *args, **kwargs)
-        log.debug("Accessing cache key %s", key)
+        #log.debug("Accessing cache key %s", key)
         return cache.get_or_create(key, creator)
 
     return inner
@@ -77,7 +77,7 @@ def invalidate_cache(widget, *args, **kwargs):
     cache.delete(key)
 
 
-def cache_key_generator(widget, args, kwargs):
+def cache_key_generator(widget, *args, **kwargs):
     return "|".join([
         str(widget.idx),
         json.dumps(args),
diff --git a/hubs/widgets/feed.py b/hubs/widgets/feed.py
index 8ae603f..de793f5 100755
--- a/hubs/widgets/feed.py
+++ b/hubs/widgets/feed.py
@@ -1,7 +1,7 @@
 from __future__ import print_function
 
 from hubs.hinting import hint
-from hubs.widgets.base import argument
+from hubs.widgets.base import argument, cache
 from hubs.widgets import templating
 
 import fmn.lib
@@ -61,7 +61,6 @@ def apply_markup(match):
 
     return markup
 
-
 @argument(name="username",
           default=None,
           validator=validators.username,
@@ -71,15 +70,11 @@ def apply_markup(match):
           validator=validators.fmn_context,
           help="A FMN context.")
 def data(session, widget, username, fmn_context):
-    openid = '%s.id.fedoraproject.org' % username
-    url = '/'.join([fmn_url, 'api', openid, fmn_context])
-    log.info("Getting FMN preferences from %s" % url)
-    response = requests.get(url)
     messages = []
     matches = []
-    if response.status_code == 200:
-        preference = response.json()
-        preference = rehydrate_preferences(preference)
+    preference = get_remote_preference(username, fmn_context)
+    if preference:
+        preference = rehydrate_preference(preference)
 
         # The smaller we make this, the faster it is.
         delta = datetime.timedelta(days=365)
@@ -110,7 +105,7 @@ def data(session, widget, username, fmn_context):
             if recipients:
                 matches.append(original)
     else:
-        log.warn("You don't have any preferences. \n Url=%s" % url)
+        log.warn("You don't have any preferences.")
 
     # TODO - sort messages and remove duplicates
 
@@ -141,14 +136,34 @@ def data(session, widget, username, fmn_context):
     )
 
 
-@hint()
+@hint(ubiquitous=True)
 def should_invalidate(message, session, widget):
-    # only if a new message would match the FMN filters would this be
-    # invalidated... but that is as expensive as being FMN ourselves.
-    raise NotImplementedError
+    username = widget.config['username']
+    fmn_context = widget.config['fmn_context']
+    preference = get_remote_preference(username, fmn_context)
+    if not preference:
+        return False
+    preference = rehydrate_preference(preference)
+    recipients = fmn.lib.recipients([preference], message, paths, config)
+    return bool(recipients)
+
+
+# TODO -- this cache value needs its own FMN-based invalidator...
+@cache.cache_on_arguments()
+def get_remote_preference(username, fmn_context):
+    openid = '%s.id.fedoraproject.org' % username
+    url = '/'.join([fmn_url, 'api', openid, fmn_context])
+    log.info("Getting FMN preference from %s" % url)
+    response = requests.get(url)
+    if bool(response):
+        return response.json()
+    else:
+        # Some people have no FMN preferences, but when they do get some.. then
+        # we'll receive the fedmsg event about it and bust this cache value.
+        return None
 
 
-def rehydrate_preferences(preference):
+def rehydrate_preference(preference):
     for fltr in preference['filters']:
         fltr['rules'] = [munch.Munch(r) for r in fltr['rules']]
         for rule in fltr['rules']:
diff --git a/hubs/widgets/meetings.py b/hubs/widgets/meetings.py
index 37c11ee..87edcb8 100755
--- a/hubs/widgets/meetings.py
+++ b/hubs/widgets/meetings.py
@@ -1,4 +1,4 @@
-#from hubs.hinting import hint, prefixed as _
+from hubs.hinting import hint
 from hubs.widgets.base import argument
 from hubs.widgets.chrome import panel
 from hubs.widgets import templating
@@ -6,6 +6,8 @@ from hubs.widgets import templating
 from hubs import validators
 from hubs import utils
 
+import hubs.models
+
 import arrow
 import collections
 import datetime
@@ -23,30 +25,34 @@ def next_meeting(meetings):
                             meeting['meeting_time_stop'])
         stop_dt = datetime.datetime.strptime(stop_string, "%Y-%m-%d %H:%M:%S")
 
-        if now < start_dt:
-            meeting['human_time'] = arrow.get(start_dt).humanize()
-            meeting['start_date'] = start_dt.strftime('%b %d')
-            meeting['stop_date'] = stop_dt.strftime('%b %d')
-            meeting['display_time'] = True
-            meeting['display_duration'] = False
-            # Just UTC for now until we do this on the client and can access
-            # their local with moment.js.
-            meeting['start_time'] = meeting['meeting_time_start'][:-3] + " UTC"
-            meeting['stop_time'] = meeting['meeting_time_stop'][:-3] + " UTC"
-            meeting['location'] = meeting['meeting_location']
-            if '@' in meeting['location']:
-                meeting['location'] = '#' + meeting['location'].split('@')[0]
-            if stop_dt - start_dt >= datetime.timedelta(hours=24) :
-                meeting['display_time'] = False
-                if stop_dt - start_dt > datetime.timedelta(hours=24) :
-                    meeting['display_duration'] = True
-            return meeting
+        # Loop over them until we find a good one.
+        # Meetings before now are no good.  We want the first one after now.
+        if start_dt < now:
+            continue
+
+        meeting['start_dt'] = start_dt
+        meeting['start_date'] = start_dt.strftime('%b %d')
+        meeting['stop_date'] = stop_dt.strftime('%b %d')
+        meeting['display_time'] = True
+        meeting['display_duration'] = False
+        # Just UTC for now until we do this on the client and can access
+        # their local with moment.js.
+        meeting['start_time'] = meeting['meeting_time_start'][:-3] + " UTC"
+        meeting['stop_time'] = meeting['meeting_time_stop'][:-3] + " UTC"
+        meeting['location'] = meeting['meeting_location']
+        if '@' in meeting['location']:
+            meeting['location'] = '#' + meeting['location'].split('@')[0]
+        if stop_dt - start_dt >= datetime.timedelta(hours=24) :
+            meeting['display_time'] = False
+            if stop_dt - start_dt > datetime.timedelta(hours=24) :
+                meeting['display_duration'] = True
+        return meeting
 
     return None
 
 
 chrome = panel('Reminders', key='meetings')
-templating.environment.filters['next_meeting'] = next_meeting
+templating.environment.filters['humanize'] = lambda d: arrow.get(d).humanize()
 template = templating.environment.get_template('templates/meetings.html')
 
 
@@ -59,24 +65,36 @@ def data(session, widget, calendar):
     url = base % calendar
     response = requests.get(url).json()
 
-    meetings = collections.defaultdict(list)
+    tmp = collections.defaultdict(list)
     for meeting in response['meetings']:
         meeting['meeting_information_html'] = utils.markup(
             meeting['meeting_information'])
-        meetings[meeting['meeting_name']].append(meeting)
+        tmp[meeting['meeting_name']].append(meeting)
 
-    return dict(meetings=dict(meetings))
+    meetings = {}
+    for title, items in tmp.items():
+        selected = next_meeting(items)
+        if not selected:
+            continue
+        meetings[title] = selected
 
+    return dict(meetings=meetings)
 
+
+@hint(ubiquitous=True)
 def should_invalidate(message, session, widget):
-    # TODO -- we have a hard problem here.
-    # There is no event which should invalidate this widget...
-    # but we do need to expire ourselves after the date of the meeting we
-    # cached has passed.
-    # Perhaps we should expand the should_invalidate API to return a tuple:
-    #  - True/False if we should or shouldn't invalidate.
-    #  - an expiry in seconds where -1 is default and means "never expire"
-    # with that.. we could have this function return the timestamp of the
-    # meeting in seconds.. such that once it has passed, our cache will free
-    # up.
-    raise NotImplementedError()
+
+    # TODO -- first, if this is a fedocal widget, we need to just invalidate
+    # ourselves right away.
+
+    # second, check our old cache value and see if any of our meetings have
+    # passed by in time.
+    old_data = data(session, widget, **widget.config)
+    meetings = old_data['meetings']
+    now = datetime.datetime.utcnow()
+    for title, meeting in meetings.items():
+        assert type(meeting['start_dt']) == type(now)
+        if meeting['start_dt'] < now:
+            return True
+
+    return False
diff --git a/hubs/widgets/stats.py b/hubs/widgets/stats.py
index 7f329cf..3b784e3 100755
--- a/hubs/widgets/stats.py
+++ b/hubs/widgets/stats.py
@@ -36,7 +36,7 @@ def data(session, widget):
     )
 
 
-@hint(topics=_('hubs.hub.update'))
+@hint(topics=[_('hubs.hub.update')])
 def should_invalidate(message, session, widget):
     if message['topic'].endswith('hubs.hub.update'):
         if message['msg']['hub']['name'] == widget.hub.name:
diff --git a/hubs/widgets/subscriptions.py b/hubs/widgets/subscriptions.py
index 6d7e52f..6576516 100755
--- a/hubs/widgets/subscriptions.py
+++ b/hubs/widgets/subscriptions.py
@@ -1,4 +1,4 @@
-# from hubs.hinting import hint, prefixed as _
+from hubs.hinting import hint, prefixed as _
 from hubs.widgets.base import argument
 from hubs.widgets.chrome import panel
 from hubs.widgets import templating
@@ -9,6 +9,9 @@ import hubs.models
 
 from fedmsg.meta.base import BaseConglomerator as BC
 
+import fedmsg.config
+fm_config = fedmsg.config.load_config()
+
 import flask
 
 chrome = panel('Hubs', key='associations')
@@ -47,5 +50,8 @@ def manage_subscriptions(items):
     ]
 
 
+@hint(topics=[_('hubs.associate')])
 def should_invalidate(message, session, widget):
-    raise NotImplementedError()
+    username = widget.config['username']
+    users = fedmsg.meta.msg2usernames(message, **fm_config)
+    return username in users
diff --git a/populate.py b/populate.py
index 9f1816c..5e89881 100755
--- a/populate.py
+++ b/populate.py
@@ -48,8 +48,6 @@ widget = hubs.models.Widget(plugin='about', index=3,
                             }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='cobwebs', index=0, left=True)
-hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='sticky', index=1, left=True,
                             _config=json.dumps({
                                 'text': "<p>The Fedora I18N project works on internationalization (i18n) to support the localization (l10n) of Fedora in many languages. Translation of Fedora software and documentation are handled by the Fedora L10N project.</p> <p>The goals of the Project are to:</p> <ul><li>Develop, package, and maintain applications like input methods for different languages</li> <li>Improve applications and utilities to support and process different languages</li> <li>Quality-assure that existing applications meet i18n standards</li> <li>Support the infrastructure of the Fedora Localization Project</li></ul>",
@@ -93,8 +91,6 @@ widget = hubs.models.Widget(plugin='about', index=3,
                             }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='cobwebs', index=0, left=True)
-hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='sticky', index=1, left=True,
                             _config=json.dumps({
                                 'text': "Bringing more heat and light to Fedora, so you don't have to choose between 'building things' and 'building communities that build things.'",
@@ -140,8 +136,6 @@ widget = hubs.models.Widget(plugin='about', index=3,
                             }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='cobwebs', index=0, left=True)
-hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='sticky', index=1, left=True,
                             _config=json.dumps({
                                 'text': "The Fedora Marketing Team develops and executes marketing strategies to promote the usage and support of Fedora worldwide. Through the development of processes and content, this project aims to support the efforts of other Fedora projects to spread Fedora and to provide a central repository of ideas and information that can be used to deliver Fedora to new audiences. We work closely with the Fedora Ambassadors who spread the word about Fedora at events and allow the Fedora Project to interact directly with its existing and prospective users. ",
@@ -188,8 +182,6 @@ widget = hubs.models.Widget(plugin='about', index=3,
                             }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='cobwebs', index=0, left=True)
-hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='sticky', index=1, left=True,
                             _config=json.dumps({
                                 'text': "The Design Team is the design group of the Fedora project. Our interests are not only in creating graphics for use by the Fedora community, but also in advocating the use of the creative tools that are a part of Fedora.",
@@ -237,8 +229,6 @@ widget = hubs.models.Widget(plugin='about', index=3,
                             }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='cobwebs', index=0, left=True)
-hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='sticky', index=2, left=True,
                             _config=json.dumps({
                                 'text': "The Infrastructure Team consists of dedicated volunteers and professionals managing the servers, building the tools and utilities, and creating new applications to make Fedora development a smoother process. We're located all over the globe and communicate primarily by IRC and e-mail. ",

